from mDummySignalSource import DummySignalSource
from HSCProgrammer import QPort
from USBCaptureTrig import USBCaptureTrig
from USBHSCProgrammer import USBQPort
from basicPlots import BasicPlot
import numpy as np
import time
from logPlots import Log

boardType="HSC1433"#"AFE79FMC"#"HSC1386"#"HSC1363"#"HSC1430"#"HSC1433"
import sys,os
chipId=0x79
chipVersion=0x13
import Afe79xxLibraries
reload(Afe79xxLibraries)
folderName=Afe79xxLibraries.getFolderName(chipId,chipVersion)
info(folderName)

import mpsseSPI
reload(mpsseSPI)

useMpsse = True

#### signal and clock source
sigSource=DummySignalSource(addr="Null",name="Signal Source Dummy")
clkSource=DummySignalSource(addr="Null",name="clk Source Dummy")
DevClkSource=DummySignalSource(addr="Null",name="DevClkSource")
imdSource=DummySignalSource(addr="Null",name="imd Source Dummy")

if boardType in ["AFE79FMC"]:
	adcregProg = ""#USBQPort(name="Kintex RegProgrammer",addr=handle+" A")	
	lmkregProg = USBQPort(name="Kintex RegProgrammer", addr="TSW14J58_CTRL C")
	cpldRegProg = ""
	cRegProg = ""
	simulationMode=False
else:
	(found,usbHandleName,boardTypeRead) = Afe79xxLibraries.getBoardType()
	if boardTypeRead!="":
		boardType=boardTypeRead

	if found:
		if useMpsse:
			adcregProg = mpsseSPI.spi(addr = usbHandleName+" A")
			adcregProg.clockDivideBy5 = True
			adcregProg.clockDivider = 1
		else:
			adcregProg = USBQPort(name="Kintex RegProgrammer",addr=usbHandleName+" A")
		
		lmkregProg = USBQPort(name="Kintex RegProgrammer",addr=usbHandleName+" B")
		cpldRegProg = USBQPort(name="Kintex RegProgrammer",addr=usbHandleName+" D")
		cRegProg = USBQPort(name="Kintex RegProgrammer",addr=usbHandleName+" C")
		simulationMode=False
	else:
		error("Got an error Connecting to hardware. Running in Simulation Mode.")
		adcregProg = ""
		lmkregProg = ""
		simulationMode=True
		cpldRegProg=""
		cRegProg=None
		
		
foundFtdiReset = Afe79xxLibraries.detectFtdiReset()
if foundFtdiReset:
	fpgaResetFtdi=USBQPort(name="FPGA reset",addr="TSW14J58_CTRL B")
else:
	fpgaResetFtdi=None
